Bug 1572084 - Review Request: colin - Tool to check generic rules/best-practices for containers/images/dockerfiles
Summary: Review Request: colin - Tool to check generic rules/best-practices for contai...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: 27
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-04-26 07:28 UTC by Petr Hracek
Modified: 2018-05-15 20:04 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-05-05 22:28:02 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Petr Hracek 2018-04-26 07:28:56 UTC
Spec URL: https://phracek.fedorapeople.org/colin.spec
SRPM URL: https://phracek.fedorapeople.org/colin-0.0.4-1.fc27.src.rpm
Description: `colin` is a tool to check generic rules/best-practices
for containers/images/dockerfiles.
Fedora Account System Username: phracek

Comment 1 Petr Hracek 2018-04-26 07:30:19 UTC
$ rpmlint /home/phracek/work/programming/colin/colin-0.0.4-1.fc27.src.rpm
colin.src: W: spelling-error Summary(en_US) dockerfiles -> docker files, docker-files, dockworkers
colin.src: W: summary-ended-with-dot C Tool to check generic rules/best-practices for containers/images/dockerfiles.
colin.src: W: spelling-error %description -l en_US dockerfiles -> docker files, docker-files, dockworkers
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

Comment 2 Petr Hracek 2018-04-26 08:01:10 UTC
$ cat /home/phracek/work/programming/colin/review-colin/review.txt

This is a review *template*. Besides handling the [ ]-marked tests you are
also supposed to fix the template before pasting into bugzilla:
- Add issues you find to the list of issues on top. If there isn't such
  a list, create one.
- Add your own remarks to the template checks.
- Add new lines marked [!] or [?] when you discover new things not
  listed by fedora-review.
- Change or remove any text in the template which is plain wrong. In this
  case you could also file a bug against fedora-review
- Remove the "[ ] Manual check required", you will not have any such lines
  in what you paste.
- Remove attachments which you deem not really useful (the rpmlint
  ones are mandatory, though)
- Remove this text



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* GPL (v3 or later)", "Unknown or generated". 183
     files have unknown license. Detailed output of licensecheck in
     /home/phracek/work/programming/colin/review-colin/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/colin
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/colin
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[ ]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[ ]: Spec file is legible and written in American English.
[ ]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[ ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-colin , colin-doc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: colin-0.0.4-1.fc27.noarch.rpm
          python3-colin-0.0.4-1.fc27.noarch.rpm
          colin-doc-0.0.4-1.fc27.noarch.rpm
          colin-0.0.4-1.fc27.src.rpm
colin.noarch: W: spelling-error Summary(en_US) dockerfiles -> docker files, docker-files, dockworkers
colin.noarch: W: summary-ended-with-dot C Tool to check generic rules/best-practices for containers/images/dockerfiles.
colin.noarch: W: spelling-error %description -l en_US dockerfiles -> docker files, docker-files, dockworkers
colin.noarch: W: no-documentation
colin.noarch: W: no-manual-page-for-binary colin
python3-colin.noarch: W: spelling-error Summary(en_US) dockerfiles -> docker files, docker-files, dockworkers
python3-colin.noarch: W: summary-ended-with-dot C Tool to check generic rules/best-practices for containers/images/dockerfiles.
python3-colin.noarch: W: spelling-error %description -l en_US dockerfiles -> docker files, docker-files, dockworkers
colin-doc.noarch: W: summary-not-capitalized C colin documentation
colin.src: W: spelling-error Summary(en_US) dockerfiles -> docker files, docker-files, dockworkers
colin.src: W: summary-ended-with-dot C Tool to check generic rules/best-practices for containers/images/dockerfiles.
colin.src: W: spelling-error %description -l en_US dockerfiles -> docker files, docker-files, dockworkers
4 packages and 0 specfiles checked; 0 errors, 12 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
python3-colin.noarch: W: spelling-error Summary(en_US) dockerfiles -> docker files, docker-files, dockworkers
python3-colin.noarch: W: summary-ended-with-dot C Tool to check generic rules/best-practices for containers/images/dockerfiles.
python3-colin.noarch: W: spelling-error %description -l en_US dockerfiles -> docker files, docker-files, dockworkers
python3-colin.noarch: W: invalid-url URL: https://github.com/user-cont/colin <urlopen error [Errno -2] Name or service not known>
colin.noarch: W: spelling-error Summary(en_US) dockerfiles -> docker files, docker-files, dockworkers
colin.noarch: W: summary-ended-with-dot C Tool to check generic rules/best-practices for containers/images/dockerfiles.
colin.noarch: W: spelling-error %description -l en_US dockerfiles -> docker files, docker-files, dockworkers
colin.noarch: W: invalid-url URL: https://github.com/user-cont/colin <urlopen error [Errno -2] Name or service not known>
colin.noarch: W: no-documentation
colin.noarch: W: no-manual-page-for-binary colin
colin-doc.noarch: W: summary-not-capitalized C colin documentation
colin-doc.noarch: W: invalid-url URL: https://github.com/user-cont/colin <urlopen error [Errno -2] Name or service not known>
3 packages and 0 specfiles checked; 0 errors, 12 warnings.



Requires
--------
python3-colin (rpmlib, GLIBC filtered):
    docker
    python(abi)
    python3-click
    python3-docker
    python3-pyxattr
    python3-requests

colin (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python3-colin

colin-doc (rpmlib, GLIBC filtered):



Provides
--------
python3-colin:
    python3-colin
    python3.6dist(colin)
    python3dist(colin)

colin:
    colin

colin-doc:
    colin-doc



Source checksums
----------------
https://files.pythonhosted.org/packages/source/c/colin/colin-0.0.4.tar.gz :
  CHECKSUM(SHA256) this package     : 64c3bfb810ddff93829c0bddad0c5635b793010da66fdd9d494dfc5d9a5fa89a
  CHECKSUM(SHA256) upstream package : 64c3bfb810ddff93829c0bddad0c5635b793010da66fdd9d494dfc5d9a5fa89a


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review --name colin
Buildroot used: fedora-27-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 3 Robert-André Mauchin 🐧 2018-04-26 14:34:34 UTC
 - [!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/colin

   Fix this by removing the asterisk:

%{_datadir}/%{pypi_name}/

 - Use the new %{?python_enable_dependency_generator} to generate the Requires automatically. Note that it will add python3.6dist(conu) >= 0.3.0rc0 as a Requires, so you may need to update that package first.

 - Simply use "doc" as a package name:


%package doc
Summary:        colin documentation

%description doc
Documentation for colin.

%files doc


 - Build the doc with Sphinx instead of packaging the source files:

BuildRequires:  python3-sphinx

   And:

%build
%py3_build

make html
rm build/html/.{doctrees,buildinfo}

   Then install them in %files:

%files doc
%license LICENSE
%doc build/html

   It seems the Makefile(s) are missing from the archive, either grab the source from Github or ask upstream to fix their archive.

Source0:        %{url}/archive/v%{version}/%{pypi_name}-%{version}.tar.gz

 - Running the tests would be nice too

 - Remove the dot at the end of summary:

colin.noarch: W: summary-ended-with-dot C Tool to check generic rules/best-practices for containers/images/dockerfiles.

Comment 4 Petr Hracek 2018-05-02 09:49:54 UTC
I have updated SPEC file and both files are updated on fedorapeople.org
Spec URL: https://phracek.fedorapeople.org/colin.spec
SRPM URL: https://phracek.fedorapeople.org/colin-0.0.4-2.fc27.src.rpm

Hopefully I have addressed all issues.
conu is not packaged as a Fedora package.

Comment 5 Robert-André Mauchin 🐧 2018-05-02 10:53:23 UTC
 - Remove the dot at the end of summary:

colin.noarch: W: summary-ended-with-dot C Tool to check generic rules/best-practices for containers/images/dockerfiles.

 - You didn't remove the Sphinx leftovers correctly.

colin-doc.noarch: W: hidden-file-or-dir /usr/share/doc/colin-doc/html/.buildinfo
colin-doc.noarch: W: hidden-file-or-dir /usr/share/doc/colin-doc/html/.doctrees
colin-doc.noarch: W: hidden-file-or-dir /usr/share/doc/colin-doc/html/.doctrees

# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}

 - conu is there: https://src.fedoraproject.org/rpms/conu ? You're co maintainer on it. You'll need to update it anyway if you want to be able to install this package.

Comment 6 Petr Hracek 2018-05-02 11:51:26 UTC
Upps, sorry, I have totally forgot it. (regarding conu).

Spec URL: https://phracek.fedorapeople.org/colin.spec
SRPM URL: https://phracek.fedorapeople.org/colin-0.0.4-3.fc27.src.rpm

I have asked for updating conu as well.

Comment 7 Robert-André Mauchin 🐧 2018-05-02 13:31:02 UTC
 I still see the dot at the end of the summary.


 Anyway, package approved.

Comment 8 Petr Hracek 2018-05-03 07:03:51 UTC
colin is already updated https://koji.fedoraproject.org/koji/buildinfo?buildID=1078531

Comment 9 Gwyn Ciesla 2018-05-03 12:32:22 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/colin

Comment 10 Fedora Update System 2018-05-03 13:07:43 UTC
colin-0.0.4-3.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-28f57e0247

Comment 11 Fedora Update System 2018-05-03 13:20:55 UTC
colin-0.0.4-3.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2018-f061528c22

Comment 12 Fedora Update System 2018-05-05 22:28:02 UTC
colin-0.0.4-3.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.

Comment 13 Fedora Update System 2018-05-06 10:05:57 UTC
colin-0.0.4-3.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-28f57e0247

Comment 14 Fedora Update System 2018-05-15 20:04:59 UTC
colin-0.0.4-3.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.